﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;

namespace habbo.Kernel.Packets.Messages
{
    public class ServerPacket
    {
        public List<byte> Message;

        public ServerPacket(int Header)
        {
            Message = new List<byte>();
            AppendHeader(Header);
        }

        private void AppendHeader(int headerId)
        {
            Short((short) headerId);
        }

        public void Append(object e)
        {
            if (e == null)
            {
                return;
            }

            if (e is int)
            {
                Integer((int)e);
            }
            else if (e is short)
            {
                Short((short)e);
            }
            else if (e is bool)
            {
                Boolean((bool)e);
            }
            else
            {
                UTF((string)e);
            }

        }

        public void Integer(int Int32)
        {
            AddBytes(BitConverter.GetBytes(Int32), true);
        }

        public void Short(short Short)
        {
            AddBytes(BitConverter.GetBytes(Short), true);
        }

        public void UTF(string String)
        {
            Short((short)String.Length);
            AddBytes(Encoding.Default.GetBytes(String), false);
        }

        public void Boolean(bool Bool)
        {
            AddBytes(new byte[] { (Bool) ? (byte)1 : (byte)0 }, false);
        }

        public void AddBytes(byte[] Bytes, bool IsInt)
        {
            if (IsInt)
            {
                for (int i = Bytes.Length - 1; i > -1; i--)
                {
                    this.Message.Add(Bytes[i]);
                }
            }
            else
            {
                this.Message.AddRange(Bytes);
            }
        }

        public byte[] ToByteArray()
        {
            List<byte> NewMsg = new List<byte>();

            NewMsg.AddRange(BitConverter.GetBytes(Message.Count));
            NewMsg.Reverse();
            NewMsg.AddRange(Message);
            return NewMsg.ToArray();
        }
    }
}
